DESCRIPTION
===========
Super simple module that does 3 things:

  * Provides a configurable “Download this node” link.
  * Sends an email with a link to the download using a unique code.
  * If the code is valid takes you to the download.
  
What a download is it's up to you. You can, for instance, hide a field holding a file for the teaser and the full node view and show it in the download page.

THEME
=====
The module provides integration with the theme system, allowing you to run
separate preprocess functions and to use a custom <code>node--edwd.tpl.php</code> in your
theme.

You can hold a different template for each node type by creating a template
called <code>node--edwd--[node-type].tpl.php</code> in your theme.

To do this copy your <code>node.tpl.php</code> in your theme folder, rename it
to <code>node--edwd.tpl.php</code> and make the changes your need.

You can implement <code>template\_preprocess\_node(…)</code> and check for the
*view_mode* called *email_downloadable*. Then you can add your custom
variables for the template.

To perform basic theming you can use the view mode in the *Manage Display*
section for your content type to customize the way your content will look like
when viewing the download page.

With this node you can track the number of unique (one for email address)
downloads foreach node (although there is no interface for that yet).

RULES
=====

This module provides hook integration and rules integration. The following are
available to you via the Rules UI.

Events:

  * A node has been requested to download. This condition provides the email
    of the requester and the node entity requested.
  * A download page has been visited. This condition provides the visited node
    an the download code.

Actions:

  * Generate the download code given a node and an email.
  * Generate the download link given a node and an email.
