<?php

/**
 * @file
 * This file contains Rules integration code.
 */

/**
 * Implements hook_rules_action_info() on behalf of the user module.
 */
function email_downloadable_rules_action_info() {
  $defaults = array(
   'parameter' => array(
      'email' => array(
        'type' => 'text',
        'label' => t('Email'),
      ),
    ),
    'group' => t('Email downloadable'),
  );
  $items['email_downloadable_provide_code'] = $defaults + array(
    'label' => t('Provide the download code'),
    'provides' => array(
      'email_downloadable_code' => array(
        'type' => 'text',
        'label' => t('Download code'),
      ),
    ),
  );
  $items['email_downloadable_provide_link'] = $defaults + array(
    'label' => t('Provide the download link'),
    'provides' => array(
      'email_downloadable_link' => array(
        'type' => 'uri',
        'label' => t('Download link'),
      ),
    ),
  );
  $items['email_downloadable_provide_link']['parameter'] += array(
    'node' => array(
      'type' => 'node',
      'label' => t('Node'),
    ),
  );
  return $items;
}

/**
 * Implementation of hook_rules_event_info().
 */
function email_downloadable_rules_event_info() {
  $defaults = array(
    'group' => t('Email downloadable'),
    'module' => 'email_downloadable',
  );
  $items['email_downloadable_rules_event_requested'] = $defaults + array(
    'label' => t('After requesting a download code'),
    'variables' => array(
      'node' => array('type' => 'node', 'label' => t('Requested node')),
      'email' => array('type' => 'text', 'label' => t('Download Email')),
      'code' => array('type' => 'text', 'label' => t('Download code')),
    ),
  );
  $items['email_downloadable_rules_event_visited'] = $defaults + array(
    'label' => t('When visiting a node download'),
    'variables' => array(
      'node' => array('type' => 'node', 'label' => t('Downloaded node')),
      'code' => array('type' => 'text', 'label' => t('Download code')),
    ),
  );
  return $items;
}

/**
 * Action: Download Code.
 */
function email_downloadable_provide_code($email) {
  return array('email_downloadable_code' => _email_downloadable_get_code($email));
}

/**
 * Action: Download Link.
 */
function email_downloadable_provide_link($email, $node) {
  $code = _email_downloadable_get_code($email);
  $uri = url('node/' . $node->nid . '/email-downloadable/download/' . $code, array('absolute' => TRUE));
  return array('email_downloadable_link' => $uri);
}